unit WebModuleUnit1;

interface

uses System.SysUtils, System.Classes, Web.HTTPApp;

type
  TWebModule1 = class(TWebModule)
    procedure WebModule1DefaultHandlerAction(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
    procedure WebModule1WebActionItem1Action(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
    procedure WebModule1WebActionItem2Action(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  WebModuleClass: TComponentClass = TWebModule1;

implementation

uses
  FormUnit1, Jpeg, Graphics;

{%CLASSGROUP 'Vcl.Controls.TControl'}

{$R *.dfm}

procedure TWebModule1.WebModule1DefaultHandlerAction(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
begin
  Response.Content :=
    '<html>' +
    '<head><title>Application TeeChart WebBroker</title></head>' +
    '<body>Application TeeChart WebBroker :' +
    '<br> ' +
    Format('<IMG2 SRC="http://localhost:%s/chart" />', [MainForm.EditPort.Text]) +
    '<br> ' +
    Format('<IMG SRC="http://localhost:%s/chart2" />', [MainForm.EditPort.Text]) +
    '<br> ' +
    '</body>' +
    '</html>';
end;


// METHOD #1 : TeeCreateBitmap
procedure TWebModule1.WebModule1WebActionItem1Action(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
var
  Jpg: TJpegImage;
  S: TMemoryStream;
  Bitmap: TBitmap;
begin
  try
      Bitmap := MainForm.Chart1.TeeCreateBitmap(clWhite, Rect(0, 0, MainForm.Chart1.Width, MainForm.Chart1.Height));
      Jpg := TJpegImage.Create;
      Jpg.Assign(Bitmap);

      S := TMemoryStream.Create;
      Jpg.SaveToStream(S);
      S.Position := 0;
      Response.ContentType := 'image/jpeg';
      Response.ContentStream := S; // do not free the stream because the response
                                   // object will handle that task.
      Bitmap.Free;
      Jpg.Free;
  except
    on Ex: Exception do
      Response.Content := 'ERROR : ' + Ex.Message;
    else
      Response.Content := 'ERROR !';
    Response.ContentType := 'text/plain';
  end;
end;

// METHOD #2 : Draw
procedure TWebModule1.WebModule1WebActionItem2Action(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
var
  Jpg: TJpegImage;
  S: TMemoryStream;
  Bitmap: TBitmap;
begin
  try
      Bitmap := TBitmap.Create;
      Bitmap.Width := MainForm.Chart1.Width;
      Bitmap.Height := MainForm.Chart1.Height;
      MainForm.Chart1.Draw(Bitmap.Canvas, Rect(0, 0, Bitmap.Width, Bitmap.Height));
      Jpg := TJpegImage.Create;
      Jpg.Assign(Bitmap);

      S := TMemoryStream.Create;
      Jpg.SaveToStream(S);
      S.Position := 0;
      Response.ContentType := 'image/jpeg';
      Response.ContentStream := S; // do not free the stream because the response
                                   // object will handle that task.
      Bitmap.Free;
      Jpg.Free;
  except
    on Ex: Exception do
      Response.Content := 'ERROR : ' + Ex.Message;
    else
      Response.Content := 'ERROR !';
    Response.ContentType := 'text/plain';
  end;
end;

end.
